--- old/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
+++ new/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
@@ -4890,9 +7434,13 @@
 	QMEM_WR64(qlt, (&req[0x34]), (bctl->bctl_dev_addr +
 	    qcmd->param.resp_offset));
 	QMEM_WR32(qlt, (&req[0x3C]), els->els_resp_size);
-	qlt_submit_req_entries(qlt, 1);
-	mutex_exit(&qlt->req_lock);
 
+	EL(qlt, "ELS opcode %xh to %xh\n",
+	    req[0x16], cmd->cmd_rp->rp_id);
+
+	qlt_submit_req_entries(qlt, 1, qi);
+	mutex_exit(&qlt->mq_req[qi].mq_lock);
+
 	return (FCT_SUCCESS);
 }
 
@@ -4905,7 +7453,10 @@
 	stmf_data_buf_t *buf;
 	qlt_dmem_bctl_t *bctl;
 	uint32_t sz, minsz;
+	uint16_t qi;
 
+	qi =  0;
+
 	ct = (fct_sol_ct_t *)cmd->cmd_specific;
 	qcmd = (qlt_cmd_t *)cmd->cmd_fca_private;
 	qcmd->flags = QLT_CMD_TYPE_SOLICITED;
@@ -4922,11 +7473,13 @@
 	    ct->ct_req_size);
 	qlt_dmem_dma_sync(buf, DDI_DMA_SYNC_FORDEV);
 
-	mutex_enter(&qlt->req_lock);
-	req = (uint8_t *)qlt_get_req_entries(qlt, 1);
+	mutex_enter(&qlt->mq_req[qi].mq_lock);
+	req = (uint8_t *)qlt_get_req_entries(qlt, 1, qi);
 	if (req == NULL) {
+		EL(qlt, "req = NULL, %xh %xh %p %xh\n", cmd->cmd_oxid,
+		    cmd->cmd_rportid, cmd, qcmd->fw_xchg_addr);
 		qlt_dmem_free(NULL, buf);
-		mutex_exit(&qlt->req_lock);
+		mutex_exit(&qlt->mq_req[qi].mq_lock);
 		return (FCT_BUSY);
 	}
 	bzero(req, IOCB_SIZE);
@@ -4946,13 +7499,229 @@
 	    qcmd->param.resp_offset));		/* RESPONSE DSD */
 	QMEM_WR32(qlt, (&req[0x3C]), ct->ct_resp_size);
 
-	qlt_submit_req_entries(qlt, 1);
-	mutex_exit(&qlt->req_lock);
+	EL(qlt, "%p cmd_hdl=%xh %xh %xh\n",
+	    cmd, cmd->cmd_handle, ct->ct_req_size, ct->ct_resp_size);
 
+	qlt_submit_req_entries(qlt, 1, qi);
+	mutex_exit(&qlt->mq_req[qi].mq_lock);
+
 	return (FCT_SUCCESS);
 }
 
+/*ARGSUSED*/
+caddr_t
+qlt_str_ptr(qlt_state_t *qlt, caddr_t bp, uint32_t *len)
+{
+	caddr_t sp;
+	uint32_t i = 0;
 
+	sp = bp;
+	while (*sp++ != 0) i++;
+	if (i > *len || !(*len -= i)) {
+		EL(qlt, "full buffer\n");
+		return (NULL);
+	}
+	return (bp += i);
+}
+
+static fct_status_t
+qlt_27xx_fw_dump(fct_local_port_t *port, stmf_state_change_info_t *ssci)
+{
+	qlt_state_t *qlt = (qlt_state_t *)port->port_fca_private;
+	qlt_dmp_template_t *template_buff;
+	uint32_t tsize, dsize, len;
+	uint32_t cnt, *dp, *bp;
+	uint8_t *fw;
+	caddr_t	sp;
+
+	EL(qlt, "enter...\n");
+
+	mutex_enter(&qlt->qlt_ioctl_lock);
+	/*
+	 * To make sure that there's no outstanding dumping task
+	 */
+	if (qlt->qlt_ioctl_flags & QLT_FWDUMP_INPROGRESS) {
+		mutex_exit(&qlt->qlt_ioctl_lock);
+		EL(qlt, "qlt_ioctl_flags=%xh, inprogress\n",
+		    qlt->qlt_ioctl_flags);
+		return (FCT_FAILURE);
+	}
+
+	/*
+	 * To make sure not to overwrite existing dump
+	 */
+	if ((qlt->qlt_ioctl_flags & QLT_FWDUMP_ISVALID) &&
+	    !(qlt->qlt_ioctl_flags & QLT_FWDUMP_TRIGGERED_BY_USER) &&
+	    !(qlt->qlt_ioctl_flags & QLT_FWDUMP_FETCHED_BY_USER)) {
+		/*
+		 * If we have already one dump, but it's not triggered by user
+		 * and the user hasn't fetched it, we shouldn't dump again.
+		 * But if qlt force a fw dump, then we need to overwrite the
+		 * previous one anyway.
+		 */
+		mutex_exit(&qlt->qlt_ioctl_lock);
+		EL(qlt, "qlt_ioctl_flags=%xh, already done\n",
+		    qlt->qlt_ioctl_flags);
+		cmn_err(CE_NOTE, "qlt(%d): Skipping firmware dump as there "
+		    "is one already outstanding.", qlt->instance);
+		return (FCT_FAILURE);
+	}
+
+	if (qlt->dmp_template_addr == NULL) {
+		mutex_exit(&qlt->qlt_ioctl_lock);
+		EL(qlt, "dmp_template_addr is NULL, can't "
+		    "perform firmware dump\n");
+		cmn_err(CE_WARN, "!qlt(%d) dmp_template_addr is NULL, can't "
+		    "perform firmware dump", qlt->instance);
+		return (FCT_FAILURE);
+	}
+
+	qlt->qlt_ioctl_flags |= QLT_FWDUMP_INPROGRESS;
+	if (ssci != NULL && (ssci->st_rflags & STMF_RFLAG_USER_REQUEST)) {
+		qlt->qlt_ioctl_flags |= QLT_FWDUMP_TRIGGERED_BY_USER;
+	} else {
+		qlt->qlt_ioctl_flags &= ~QLT_FWDUMP_TRIGGERED_BY_USER;
+	}
+	mutex_exit(&qlt->qlt_ioctl_lock);
+
+	template_buff = (qlt_dmp_template_t *)qlt->dmp_template_addr;
+	tsize = template_buff->hdr.size_of_template;
+
+	if (qlt->fw_bin_dump_size == 0) {
+		qlt->fw_bin_dump_buf = kmem_zalloc(tsize, KM_NOSLEEP);
+		if (qlt->fw_bin_dump_buf == NULL) {
+			cmn_err(CE_WARN, "!qlt(%d) cannot alloc bin dump buf",
+			    qlt->instance);
+			return (FCT_FAILURE);
+		}
+		cnt = (uint32_t)(tsize / sizeof (uint32_t));
+		dp = (uint32_t *)qlt->fw_bin_dump_buf;
+		bp = (uint32_t *)&template_buff->hdr;
+		while (cnt--) {
+			*dp++ = ddi_get32(qlt->dmp_template_acc_handle, bp++);
+		}
+		qlt->fw_bin_dump_size = qlt_27xx_dmp_parse_template(qlt,
+		    (qlt_dt_hdr_t *)qlt->fw_bin_dump_buf, NULL, 0);
+		kmem_free(qlt->fw_bin_dump_buf, tsize);
+		qlt->fw_bin_dump_buf = NULL;
+
+		if (qlt->fw_bin_dump_size == 0) {
+			return (FCT_FAILURE);
+		}
+
+		/*
+		 * Determine ascii dump file size
+		 * 2 ascii bytes per binary byte + a space and
+		 * a newline every 16 binary bytes
+		 */
+		qlt->fw_ascii_dump_size = qlt->fw_bin_dump_size << 1;
+		qlt->fw_ascii_dump_size += qlt->fw_bin_dump_size;
+		qlt->fw_ascii_dump_size += qlt->fw_bin_dump_size / 16 + 1;
+
+		EL(qlt, "fw_bin_dump_size=%xh, "
+		    "fw_acsii_dump_size=%xh\n", qlt->fw_bin_dump_size,
+		    qlt->fw_ascii_dump_size);
+	}
+
+	if (qlt->fw_bin_dump_buf != NULL) {
+		/* overwrite the previous fw dump by qlt forced fw dump */
+		bzero((void *) qlt->fw_bin_dump_buf, qlt->fw_bin_dump_size);
+	} else {
+		qlt->fw_bin_dump_buf = kmem_zalloc(qlt->fw_bin_dump_size,
+		    KM_NOSLEEP);
+		if (qlt->fw_bin_dump_buf == NULL) {
+			qlt->fw_bin_dump_size = 0;
+			EL(qlt, "done, failed alloc bin dump buf\n");
+			return (FCT_FAILURE);
+		}
+	}
+
+	if ((qlt->fw_dump_size != 0) &&
+	    (qlt->fw_dump_size != qlt->fw_ascii_dump_size)) {
+		if (qlt->qlt_fwdump_buf != NULL) {
+			/* Release previously allocated buffer */
+			kmem_free(qlt->qlt_fwdump_buf, qlt->fw_dump_size);
+			qlt->qlt_fwdump_buf = NULL;
+		}
+	}
+
+	if (qlt->qlt_fwdump_buf == NULL) {
+		qlt->qlt_fwdump_buf = kmem_zalloc(qlt->fw_ascii_dump_size,
+		    KM_NOSLEEP);
+		if (qlt->qlt_fwdump_buf == NULL) {
+			EL(qlt, "done, failed alloc ascii fw dump buf\n");
+			return (FCT_FAILURE);
+		}
+		qlt->fw_dump_size = qlt->fw_ascii_dump_size;
+	}
+
+	/* Disable ISP interrupts. */
+	REG_WR32(qlt, 0xc, 0);
+
+	cnt = (uint32_t)(tsize / sizeof (uint32_t));
+	dp = (uint32_t *)qlt->fw_bin_dump_buf;
+	bp = (uint32_t *)&template_buff->hdr;
+	while (cnt--) {
+		*dp++ = ddi_get32(qlt->dmp_template_acc_handle, bp++);
+	}
+
+	(void) qlt_27xx_dmp_parse_template(qlt,
+	    (qlt_dt_hdr_t *)qlt->fw_bin_dump_buf,
+	    (uint8_t *)dp, qlt->fw_bin_dump_size);
+
+#ifdef _BIG_ENDIAN
+	cnt = (uint32_t)(tsize / sizeof (uint32_t));
+	dp = (uint32_t *)qlt->fw_bin_dump_buf;
+	while (cnt--) {
+		qlt_chg_endian((uint8_t *)dp, 4);
+		dp++;
+	}
+#endif
+
+	/*
+	 * Build ascii dump
+	 */
+	len = qlt->fw_ascii_dump_size;
+	dsize = qlt->fw_bin_dump_size;
+	fw = (uint8_t *)qlt->fw_bin_dump_buf;
+	sp = qlt->qlt_fwdump_buf;
+
+	EL(qlt, "fw_dump_buffer=%ph, fw=%ph, fw_ascii_dump_size=%xh, "
+	    "dsize=%xh\n", (void *)qlt->qlt_fwdump_buf, (void *)fw,
+	    len, dsize);
+
+	/*
+	 * 2 ascii bytes per binary byte + a space and
+	 * a newline every 16 binary bytes
+	 */
+	cnt = 0;
+	while (cnt < dsize) {
+		(void) snprintf(sp, len, "%02x ", *fw++);
+		if ((sp = qlt_str_ptr(qlt, sp, &len)) == NULL) {
+			break;
+		}
+		if (++cnt % 16 == 0) {
+			(void) snprintf(sp, len, "\n");
+			if ((sp = qlt_str_ptr(qlt, sp, &len)) == NULL) {
+				break;
+			}
+		}
+	}
+	if (cnt % 16 != 0) {
+		(void) snprintf(sp, len, "\n");
+		sp = qlt_str_ptr(qlt, sp, &len);
+	}
+
+	mutex_enter(&qlt->qlt_ioctl_lock);
+	qlt->qlt_ioctl_flags &=
+	    ~(QLT_FWDUMP_INPROGRESS | QLT_FWDUMP_FETCHED_BY_USER);
+	qlt->qlt_ioctl_flags |= QLT_FWDUMP_ISVALID;
+	mutex_exit(&qlt->qlt_ioctl_lock);
+
+	EL(qlt, "done...\n");
+	return (FCT_SUCCESS);
+}
+
 /*
  * All QLT_FIRMWARE_* will mainly be handled in this function
  * It can not be called in interrupt context
@@ -4972,6 +7741,9 @@
 	caddr_t		buf;
 	fct_status_t	ret;
 
+	if (qlt->qlt_27xx_chip) {
+		return (qlt_27xx_fw_dump(port, ssci));
+	}
 	mutex_enter(&qlt->qlt_ioctl_lock);
 	/*
 	 * To make sure that there's no outstanding dumping task
@@ -4980,7 +7752,6 @@
 		mutex_exit(&qlt->qlt_ioctl_lock);
 		EL(qlt, "qlt_ioctl_flags=%xh, inprogress\n",
 		    qlt->qlt_ioctl_flags);
-		EL(qlt, "outstanding\n");
 		return (FCT_FAILURE);
 	}
 
@@ -4991,7 +7762,7 @@
 	    !(qlt->qlt_ioctl_flags & QLT_FWDUMP_TRIGGERED_BY_USER) &&
 	    !(qlt->qlt_ioctl_flags & QLT_FWDUMP_FETCHED_BY_USER)) {
 		/*
-		 * If we have alreay one dump, but it's not triggered by user
+		 * If we have already one dump, but it's not triggered by user
 		 * and the user hasn't fetched it, we shouldn't dump again.
 		 */
 		mutex_exit(&qlt->qlt_ioctl_lock);
@@ -5002,7 +7773,7 @@
 		return (FCT_FAILURE);
 	}
 	qlt->qlt_ioctl_flags |= QLT_FWDUMP_INPROGRESS;
-	if (ssci->st_rflags & STMF_RFLAG_USER_REQUEST) {
+	if ((ssci != NULL) && (ssci->st_rflags & STMF_RFLAG_USER_REQUEST)) {
 		qlt->qlt_ioctl_flags |= QLT_FWDUMP_TRIGGERED_BY_USER;
 	} else {
 		qlt->qlt_ioctl_flags &= ~QLT_FWDUMP_TRIGGERED_BY_USER;
@@ -5010,6 +7781,10 @@
 	mutex_exit(&qlt->qlt_ioctl_lock);
 
 	size_left = QLT_FWDUMP_BUFSIZE;
+	if (qlt->qlt_mq_enabled && qlt->qlt_queue_cnt >= 8) {
+		size_left += 512 * 1024;
+	}
+	qlt->fw_dump_size = size_left;
 	if (!qlt->qlt_fwdump_buf) {
 		ASSERT(!(qlt->qlt_ioctl_flags & QLT_FWDUMP_ISVALID));
 		/*
@@ -5016,9 +7791,19 @@
 		 * It's the only place that we allocate buf for dumping. After
 		 * it's allocated, we will use it until the port is detached.
 		 */
-		qlt->qlt_fwdump_buf = kmem_zalloc(size_left, KM_SLEEP);
+		qlt->qlt_fwdump_buf = kmem_zalloc(size_left, KM_NOSLEEP);
+		if (qlt->qlt_fwdump_buf == NULL) {
+			EL(qlt, "cannot alloc fwdump buffer\n");
+			cmn_err(CE_WARN, "!qlt(%d): cannot alloc fwdump buf",
+			    qlt->instance);
+			return (FCT_FAILURE);
+		}
 	}
 
+	EL(qlt, "starting firmware dump...\n");
+	cmn_err(CE_WARN, "!qlt(%d) starting firmware dump...",
+	    qlt->instance);
+
 	/*
 	 * Start to dump firmware
 	 */
@@ -5029,7 +7814,7 @@
 	 * Read the RISC to Host Status register
 	 */
 	n = (int)snprintf(buf, size_left, "ISP FW Version %d.%02d.%02d "
-	    "Attributes %04x\n\nR2H Status Register\n%08x",
+	    "Attributes %04x\n\nR2H Status register\n%08x",
 	    qlt->fw_major, qlt->fw_minor,
 	    qlt->fw_subminor, qlt->fw_attr, REG_RD32(qlt, REG_RISC_STATUS));
 	buf += n; size_left -= n;
@@ -5038,7 +7823,8 @@
 	 * Before pausing the RISC, make sure no mailbox can execute
 	 */
 	mutex_enter(&qlt->mbox_lock);
-	if (qlt->mbox_io_state != MBOX_STATE_UNKNOWN) {
+	if ((qlt->mbox_io_state != MBOX_STATE_UNKNOWN) &&
+	    (qlt->qlt_intr_enabled)) {
 		/*
 		 * Wait to grab the mailboxes
 		 */
@@ -5076,7 +7862,21 @@
 		return (FCT_FAILURE);
 	}
 
-	if ((!qlt->qlt_25xx_chip) && (!qlt->qlt_81xx_chip)) {
+	if (qlt->qlt_83xx_chip) {
+		/* Disable ECC checks in FB registers */
+		REG_WR32(qlt, 0x54, 0x6000);
+		REG_WR32(qlt, 0xC0, 0); /* 6000h */
+		REG_WR32(qlt, 0xCC, 0); /* 6003h */
+		REG_WR32(qlt, 0x54, 0x6010);
+		REG_WR32(qlt, 0xD4, 0); /* 6015h */
+
+		/* disable ECC detection in PCR whilst dumping */
+		REG_WR32(qlt, 0x54, 0xF70);
+		REG_WR32(qlt, 0xF0, 0x60000000);
+	}
+
+	if ((!qlt->qlt_25xx_chip) && (!qlt->qlt_81xx_chip) &&
+	    (!qlt->qlt_83xx_chip) && (!qlt->qlt_27xx_chip)) {
 		goto over_25xx_specific_dump;
 	}
 	n = (int)snprintf(buf, size_left, "\n\nHostRisc registers\n");
@@ -5087,6 +7887,11 @@
 	REG_WR32(qlt, 0x54, 0x7010);
 	n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 	buf += n; size_left -= n;
+	if (qlt->qlt_83xx_chip) {
+		REG_WR32(qlt, 0x54, 0x7040);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+	}
 	REG_WR32(qlt, 0x54, 0x7C00);
 
 	n = (int)snprintf(buf, size_left, "\nPCIe registers\n");
@@ -5098,11 +7903,40 @@
 	buf += n; size_left -= n;
 	REG_WR32(qlt, 0xC0, 0x0);
 
+	/* don't need to do this for 83xx */
+	if ((!qlt->qlt_83xx_chip) && (qlt->qlt_mq_enabled)) {
+		uint16_t qi;
+
+		for (qi = 0; qi < qlt->qlt_queue_cnt; qi++) {
+
+			n = (int)snprintf(buf, size_left,
+			    "\n\nQueue Pointers #%x\n", qi);
+			buf += n; size_left -= n;
+
+			n = (int)snprintf(buf, size_left, "%08x ",
+			    MQBAR_RD32(qlt,
+			    (qi * MQBAR_REG_OFFSET) + MQBAR_REQ_IN));
+			buf += n; size_left -= n;
+			n = (int)snprintf(buf, size_left, "%08x ",
+			    MQBAR_RD32(qlt,
+			    (qi * MQBAR_REG_OFFSET) + MQBAR_REQ_OUT));
+			buf += n; size_left -= n;
+			n = (int)snprintf(buf, size_left, "%08x ",
+			    MQBAR_RD32(qlt,
+			    (qi * MQBAR_REG_OFFSET) + MQBAR_RESP_IN));
+			buf += n; size_left -= n;
+			n = (int)snprintf(buf, size_left, "%08x",
+			    MQBAR_RD32(qlt,
+			    (qi * MQBAR_REG_OFFSET) + MQBAR_RESP_OUT));
+			buf += n; size_left -= n;
+		}
+	}
+
 over_25xx_specific_dump:;
-	n = (int)snprintf(buf, size_left, "\n\nHost Interface Registers\n");
+	n = (int)snprintf(buf, size_left, "\n\nHost Interface registers\n");
 	buf += n; size_left -= n;
 	/*
-	 * Capture data from 32 regsiters
+	 * Capture data from 32 registers
 	 */
 	n = qlt_fwdump_dump_regs(qlt, buf, 0, 32, size_left);
 	buf += n; size_left -= n;
@@ -5111,11 +7945,12 @@
 	 * Disable interrupts
 	 */
 	REG_WR32(qlt, 0xc, 0);
+	EL(qlt, "Disable interrupt\n");
 
 	/*
 	 * Shadow registers
 	 */
-	n = (int)snprintf(buf, size_left, "\nShadow Registers\n");
+	n = (int)snprintf(buf, size_left, "\nShadow registers\n");
 	buf += n; size_left -= n;
 
 	REG_WR32(qlt, 0x54, 0xF70);
@@ -5123,6 +7958,7 @@
 	for (i = 0; i < 0xb; i++) {
 		if ((!qlt->qlt_25xx_chip) &&
 		    (!qlt->qlt_81xx_chip) &&
+		    (!qlt->qlt_83xx_chip) &&
 		    (i >= 7)) {
 			break;
 		}
@@ -5136,10 +7972,11 @@
 		addr += 0x100000;
 	}
 
-	if ((qlt->qlt_25xx_chip) || (qlt->qlt_81xx_chip)) {
+	if ((qlt->qlt_25xx_chip) || (qlt->qlt_81xx_chip) ||
+	    (qlt->qlt_83xx_chip)) {
 		REG_WR32(qlt, 0x54, 0x10);
 		n = (int)snprintf(buf, size_left,
-		    "\n\nRISC IO Register\n%08x", REG_RD32(qlt, 0xC0));
+		    "\n\nRISC IO register\n%08x", REG_RD32(qlt, 0xC0));
 		buf += n; size_left -= n;
 	}
 
@@ -5146,7 +7983,7 @@
 	/*
 	 * Mailbox registers
 	 */
-	n = (int)snprintf(buf, size_left, "\n\nMailbox Registers\n");
+	n = (int)snprintf(buf, size_left, "\n\nMailbox registers\n");
 	buf += n; size_left -= n;
 	for (i = 0; i < 32; i += 2) {
 		if ((i + 2) & 15) {
@@ -5163,9 +8000,35 @@
 	/*
 	 * Transfer sequence registers
 	 */
-	n = (int)snprintf(buf, size_left, "\nXSEQ GP Registers\n");
+	n = (int)snprintf(buf, size_left, "\nXSEQ GP registers\n");
 	buf += n; size_left -= n;
 
+	if (qlt->qlt_83xx_chip) {
+		REG_WR32(qlt, 0x54, 0xBE00);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xBE10);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xBE20);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xBE30);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xBE40);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xBE50);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xBE60);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xBE70);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+	}
 	REG_WR32(qlt, 0x54, 0xBF00);
 	n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 	buf += n; size_left -= n;
@@ -5192,7 +8055,8 @@
 	buf += n; size_left -= n;
 	n = (int)snprintf(buf, size_left, "\nXSEQ-0 registers\n");
 	buf += n; size_left -= n;
-	if ((qlt->qlt_25xx_chip) || (qlt->qlt_81xx_chip)) {
+	if ((qlt->qlt_25xx_chip) || (qlt->qlt_81xx_chip) ||
+	    (qlt->qlt_83xx_chip)) {
 		REG_WR32(qlt, 0x54, 0xBFC0);
 		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 		buf += n; size_left -= n;
@@ -5209,11 +8073,45 @@
 	n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 	buf += n; size_left -= n;
 
+	if (qlt->qlt_83xx_chip) {
+		n = (int)snprintf(buf, size_left, "\nXSEQ-2 registers\n");
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xBEF0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+	}
+
 	/*
 	 * Receive sequence registers
 	 */
-	n = (int)snprintf(buf, size_left, "\nRSEQ GP Registers\n");
+	n = (int)snprintf(buf, size_left, "\nRSEQ GP registers\n");
 	buf += n; size_left -= n;
+	if (qlt->qlt_83xx_chip) {
+		REG_WR32(qlt, 0x54, 0xFE00);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xFE10);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xFE20);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xFE30);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xFE40);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xFE50);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xFE60);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xFE70);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+	}
 	REG_WR32(qlt, 0x54, 0xFF00);
 	n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 	buf += n; size_left -= n;
@@ -5240,7 +8138,8 @@
 	buf += n; size_left -= n;
 	n = (int)snprintf(buf, size_left, "\nRSEQ-0 registers\n");
 	buf += n; size_left -= n;
-	if ((qlt->qlt_25xx_chip) || (qlt->qlt_81xx_chip)) {
+	if ((qlt->qlt_25xx_chip) || (qlt->qlt_81xx_chip) ||
+	    (qlt->qlt_83xx_chip)) {
 		REG_WR32(qlt, 0x54, 0xFFC0);
 		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 		buf += n; size_left -= n;
@@ -5258,14 +8157,22 @@
 	REG_WR32(qlt, 0x54, 0xFFF0);
 	n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 	buf += n; size_left -= n;
+	if (qlt->qlt_83xx_chip) {
+		n = (int)snprintf(buf, size_left, "\nRSEQ-3 registers\n");
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xFEF0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+	}
 
-	if ((!qlt->qlt_25xx_chip) && (!qlt->qlt_81xx_chip))
+	if ((!qlt->qlt_25xx_chip) && (!qlt->qlt_81xx_chip) &&
+	    (!qlt->qlt_83xx_chip))
 		goto over_aseq_regs;
 
 	/*
 	 * Auxiliary sequencer registers
 	 */
-	n = (int)snprintf(buf, size_left, "\nASEQ GP Registers\n");
+	n = (int)snprintf(buf, size_left, "\nASEQ GP registers\n");
 	buf += n; size_left -= n;
 	REG_WR32(qlt, 0x54, 0xB000);
 	n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
@@ -5291,6 +8198,32 @@
 	REG_WR32(qlt, 0x54, 0xB070);
 	n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 	buf += n; size_left -= n;
+	if (qlt->qlt_83xx_chip) {
+		REG_WR32(qlt, 0x54, 0xB100);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xB110);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xB120);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xB130);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xB140);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xB150);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xB160);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xB170);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+	}
 	n = (int)snprintf(buf, size_left, "\nASEQ-0 registers\n");
 	buf += n; size_left -= n;
 	REG_WR32(qlt, 0x54, 0xB0C0);
@@ -5309,6 +8242,13 @@
 	REG_WR32(qlt, 0x54, 0xB0F0);
 	n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 	buf += n; size_left -= n;
+	if (qlt->qlt_83xx_chip) {
+		n = (int)snprintf(buf, size_left, "\nASEQ-3 registers\n");
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0xB1F0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+	}
 
 over_aseq_regs:;
 
@@ -5320,6 +8260,17 @@
 	REG_WR32(qlt, 0x54, 0x7100);
 	n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 	buf += n; size_left -= n;
+	if (qlt->qlt_83xx_chip) {
+		REG_WR32(qlt, 0x54, 0x7120);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x7130);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x71F0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+	}
 
 	/*
 	 * Queues
@@ -5479,7 +8430,8 @@
 	n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 	buf += n; size_left -= n;
 
-	if ((qlt->qlt_25xx_chip) || (qlt->qlt_81xx_chip)) {
+	if ((qlt->qlt_25xx_chip) || (qlt->qlt_81xx_chip) ||
+	    (qlt->qlt_83xx_chip)) {
 		REG_WR32(qlt, 0x54, 0x3070);
 		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 		buf += n; size_left -= n;
@@ -5486,7 +8438,7 @@
 	}
 
 	/*
-	 * Fibre protocol module regsiters
+	 * Fibre protocol module registers
 	 */
 	n = (int)snprintf(buf, size_left, "\nFPM hardware registers\n");
 	buf += n; size_left -= n;
@@ -5526,7 +8478,7 @@
 	REG_WR32(qlt, 0x54, 0x40B0);
 	n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 	buf += n; size_left -= n;
-	if (qlt->qlt_81xx_chip) {
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_81xx_chip)) {
 		REG_WR32(qlt, 0x54, 0x40C0);
 		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 		buf += n; size_left -= n;
@@ -5534,7 +8486,226 @@
 		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 		buf += n; size_left -= n;
 	}
+	if (qlt->qlt_83xx_chip) {
+		REG_WR32(qlt, 0x54, 0x40E0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x40F0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
 
+		n = (int)snprintf(buf, size_left, "\nRQ0 Array registers\n");
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5C00);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5C10);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5C20);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5C30);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5C40);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5C50);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5C60);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5C70);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5C80);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5C90);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5CA0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5CB0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5CC0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5CD0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5CE0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5CF0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+
+		n = (int)snprintf(buf, size_left, "\nRQ1 Array registers\n");
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5D00);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5D10);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5D20);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5D30);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5D40);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5D50);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5D60);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5D70);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5D80);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5D90);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5DA0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5DB0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5DC0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5DD0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5DE0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5DF0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+
+		n = (int)snprintf(buf, size_left, "\nRP0 Array registers\n");
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5E00);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5E10);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5E20);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5E30);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5E40);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5E50);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5E60);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5E70);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5E80);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5E90);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5EA0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5EB0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5EC0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5ED0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5EE0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5EF0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+
+		n = (int)snprintf(buf, size_left, "\nRP1 Array registers\n");
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5F00);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5F10);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5F20);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5F30);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5F40);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5F50);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5F60);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5F70);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5F80);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5F90);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5FA0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5FB0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5FC0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5FD0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5FE0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x5FF0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+
+		n = (int)snprintf(buf,
+		    size_left, "\nQueue Control Registers\n");
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x7800);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+	}
+
 	/*
 	 * Fibre buffer registers
 	 */
@@ -5555,6 +8726,14 @@
 	REG_WR32(qlt, 0x54, 0x6040);
 	n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 	buf += n; size_left -= n;
+	if (qlt->qlt_83xx_chip) {
+		REG_WR32(qlt, 0x54, 0x6060);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x6070);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+	}
 	REG_WR32(qlt, 0x54, 0x6100);
 	n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 	buf += n; size_left -= n;
